require 'persisto/version'
require 'persisto/mapper'
require 'persisto/repository'
require 'persisto/query'
require 'persisto/store'

module Persisto
	def self.mapper
		mod = Module.new
		mod.define_singleton_method :included do |base|
			base.send(:include, ::Persisto::Mapper)
		end
		mod
	end

	def self.query
		mod = Module.new
		mod.define_singleton_method :included do |base|
			base.send(:include, ::Persisto::Query)
		end
		mod
	end

	def self.repository
		mod = Module.new
		mod.define_singleton_method :included do |base|
			base.send(:include, ::Persisto::Repository)
		end
		mod
	end

	def self.store
		mod = Module.new
		mod.define_singleton_method :included do |base|
			base.send(:include, ::Persisto::Store)
		end
		mod
	end
end