require 'sequel'
require 'persisto/adaptors/abstract_adaptor'

module Persisto
	class Pg < AbstractAdaptor
		def self.connect *args
			new Sequel.connect(*args)
		end

		attr_reader :database

		def initialize database
			@database = database
		end

		def select qo
			all(qo)
		end
		
		def insert qo
			single_value(qo)
		end

		def update qo
			single_value(qo)
		end

		def delete qo
			single_value(qo)
		end

		def transaction &block
			database.transaction &block
		end

		private

		def all qo
			fetch(qo).all
		end

		def single_value qo
			fetch(qo).single_value
		end

		def fetch qo
			database.fetch(qo.query)
		end
	end
end